%{?scl:%scl_package delve}
%{!?scl:%global pkg_name %{name}}

%global goproject	delve

Name:                   %{?scl_prefix}delve
Version:                1.3.2
Release:                1%{?dist}
Summary:                A debugger for the Go programming language

License:                MIT
URL:                    https://github.com/go-delve/delve
Source0:                https://github.com/go-delve/delve/archive/v%{version}.tar.gz#/%{goproject}-%{version}.tar.gz

ExcludeArch:            ppc64 ppc64le s390x aarch64 i686 armv7hl

%if 0%{?rhel} <= 7 && ! 0%{?fedora}
%define gobuild(o:) scl enable go-toolset-1.13 -- go build -buildmode pie -compiler gc -tags="rpm_crashtraceback libtrust_openssl ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -compressdwarf=false -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '%__global_ldflags'" -a -v -x %{?**};
%else
%define gobuild(o:) go build -buildmode pie -compiler gc -tags="rpm_crashtraceback libtrust_openssl ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -compressdwarf=false -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '%__global_ldflags'" -a -v -x %{?**};
%endif

%if 0%{?rhel} <= 7 && ! 0%{?fedora}
%{?scl:BuildRequires: %{scl}-build %{scl}-runtime}
BuildRequires:          %{?scl_prefix}golang
%else
BuildRequires:          golang >= 1.13.0-0
%endif
BuildRequires:          git

Provides:               %{?scl_prefix}dlv = %{version}

Patch1781:              ./1781-pkg-terminal-Fix-exit-status.patch


%description
Delve is a debugger for the Go programming language. The goal of the project 
is to provide a simple, full featured debugging tool for Go. Delve should be 
easy to invoke and easy to use. Chances are if you're using a debugger, things 
aren't going your way. With that in mind, Delve should stay out of your way as 
much as possible.


%prep
%setup -q -n %{goproject}-%{version}
%patch1781 -p1
rm -rf go.mod
mv vendor %{_builddir}/src
mkdir -p "%{_builddir}/src/github.com/go-delve/"
cp -r %{_builddir}/%{goproject}-%{version} %{_builddir}/src/github.com/go-delve/%{goproject}
mkdir -p %{_builddir}/%{goproject}-%{version}/_build
mv %{_builddir}/src %{_builddir}/%{goproject}-%{version}/_build/src


%build
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
%gobuild -o bin/dlv github.com/go-delve/delve/cmd/dlv


%install
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
install -Dpm 0755 bin/dlv %{buildroot}%{_bindir}/dlv


%check
export GO111MODULE=off
export GOPATH="%{_builddir}/%{goproject}-%{version}/_build"
cd "_build/src/github.com/go-delve/%{goproject}"

%if 0%{?rhel} <= 7 && ! 0%{?fedora}
for d in $(scl enable go-toolset-1.13 -- go list ./... | grep -v cmd | grep -v scripts); do
    scl enable go-toolset-1.13 -- go test ${d}
done
%else
for d in $(go list ./... | grep -v cmd | grep -v scripts); do
    go test ${d}
done
%endif


%files
%license LICENSE
%doc CONTRIBUTING.md CHANGELOG.md
%doc Documentation/*
%{_bindir}/dlv


%changelog
* Fri Jan 31 2020 Alejandro Sáez <asm@redhat.com> - 1.3.2-1
  - First package for RHEL 7
  - Add patch: 1781-pkg-terminal-Fix-exit-status.patch
